//
//  APIFilterScroll.swift
//  Flip
//
//  Created by Анатолий Матвеев on 11.11.2017.
//  Copyright © 2017 Flip. All rights reserved.
//


import Foundation
import UIKit


extension ScrollCatalog: SearchFilter {
    
    func reloadView(id: String, name: String) {
        filterLoad()
        self.id = Int(id)
        self.title = name
        json = nil
        productSearch = nil
        searchProduct()
    }
    
    
    
    
    
    
    
    
    func resertFilter() {
        filterLoad()
        AppDelegate.changeFilter = false
        filters.removeAll()
        search["offset"] = 0
        search["filter"] = filters
        print("RSERT FILTER", search["filter"] as Any)
        searchProduct()
    }
    
    
    func searchFilter(object: String?, secondObject: String?, id: String, type: String?) {
        
        AppDelegate.changeFilter = false
        
        var isExist = true
        
        for (index, value) in filters.enumerated() {
            
            if let iFilter = value.values.first as? String, iFilter == id {
                
                isExist = false
                
                if var values = value["values"] as? [[String : String?]] {
                    
                    if type == FilterType.range {
                        
                        values[0]["value"] = object
                        values[1]["value"] = secondObject
                        filters[index]["values"] = values
                        
                    } else {
                        
                        for i in values {
                            guard let value = i["value"] else { return }
                            if value == object {
                                print("povtor")
                                return
                            }
                        }
                        
                        let newObject = ["value": object]
                        print("newObject", newObject)
                        values.append(newObject)
                        
                        filters[index]["values"] = values
                    }
                }
                
                break
                
            }
        }
        
        filterLoad()
        
        if type == FilterType.range && isExist {
            let filter: [String : Any] = ["id": id, "values": [["value": object], ["value": secondObject]]]
            filters.append(filter)
        } else if isExist {
            let filter: [String : Any] = ["id": id, "values": [["value": object]]]
            filters.append(filter)
        }
        
        
        search["offset"] = 0
        search["filter"] = filters
        print("SEARCH FILTER", search["filter"] as Any)
        searchProduct()
    }
    
    
    func removeFilter(object: String?, secondObject: String?, id: String, type: String?) {
        filterLoad()
        AppDelegate.changeFilter = false
        
        for (index, value) in filters.enumerated() {
            
            if let iFilter = value.values.first as? String, iFilter == id {
                if var values = value["values"] as? [[String : String?]] {
                    if values.isEmpty {
                        filters.remove(at: index)
                    } else {
                        if type == FilterType.range {
                            if object == nil && secondObject == nil {
                                filters.remove(at: index)
                            }
                            
                        } else {
                            for (index2, value2) in values.enumerated() {
                                guard let value = value2["value"] else { return }
                                if value == object {
                                    values.remove(at: index2)
                                    filters[index]["values"] = values
                                    
                                    if values.isEmpty {
                                        filters.remove(at: index)
                                    }
                                    break
                                }
                            }
                        }
                    }
                }
                break
            }
        }
        
        
        search["offset"] = 0
        search["filter"] = filters
        print("REMOVE FILTER", search["filter"] as Any)
        searchProduct()
        
    }
    
    
    func filterLoad() {
        loadFilterFon = LoadFilterFon()
        loadFilterFon?.color = UIColor(white: 1, alpha: 0.5)
        
        if let window = UIApplication.shared.keyWindow {
            
            let loadFonCV = spinner
            productSearch?.products = nil
            prodSecFill.products = nil
            prodSecFill.reloadSections([0])
            loadFonCV.tag = 909
            loadFonCV.alpha = 0
            self.view.viewWithTag(909)?.alpha = 0
            
            view.addSubview(loadFonCV)
            loadFonCV.startAnimating()
            
            NSLayoutConstraint.activate([
                loadFonCV.centerYAnchor.constraint(equalTo: view.centerYAnchor),
                loadFonCV.centerXAnchor.constraint(equalTo: view.centerXAnchor)
                ])
            
            window.addSubview(loadFilterFon!)
            window.bringSubview(toFront: loadFilterFon!)
            loadFilterFon?.spinner.startAnimating()
            loadFilterFon?.alpha = 0
            
            if let viewFilter = menufilter.viewControllers.last?.view {
                NSLayoutConstraint.activate([
                    loadFilterFon!.leftAnchor.constraint(equalTo: viewFilter.leftAnchor),
                    loadFilterFon!.rightAnchor.constraint(equalTo: viewFilter.rightAnchor),
                    loadFilterFon!.topAnchor.constraint(equalTo: viewFilter.topAnchor),
                    loadFilterFon!.bottomAnchor.constraint(equalTo: viewFilter.bottomAnchor)
                    ])
            }
            
            UIView.animate(withDuration: 0.5, delay: 0, usingSpringWithDamping: 1, initialSpringVelocity: 1, options: .curveEaseOut, animations: {
                self.loadFilterFon?.alpha = 1
                self.view.viewWithTag(909)?.alpha = 1
            }, completion: nil)
            
        }
    }
    
    func filterLoadRemove() {
        UIView.animate(withDuration: 0.5, delay: 0, usingSpringWithDamping: 1, initialSpringVelocity: 1, options: .curveEaseOut, animations: {
            self.loadFilterFon?.alpha = 0
            self.view.viewWithTag(909)?.alpha = 0
        },completion: { (complete) in
            self.view.viewWithTag(909)?.removeFromSuperview()
            self.loadFilterFon?.spinner.stopAnimating()
            self.loadFilterFon?.removeFromSuperview()
        })
    }
    
    
    
    
    
    
    
    
    
    
    //--filter
    
    @objc func handleSwipeCloseMenu(_ sender: UISwipeGestureRecognizer) {
        
        if sender.direction == .right {
            editFilterMenu()
        }
    }
    
    @objc func handleBlackView() {
        editFilterMenu()
    }
    
    @objc func editFilterMenu() {
        
        if AppDelegate.isShowMenu {
            showMenuFilter()
        } else {
            closeMenuFilter()
        }
    }
    
    
    func showMenuFilter() {
        
        dismissSortMenu()
        menufilter.view.isHidden = false
        
        let x = UIScreen.main.bounds.size.width - widthMenu
        
        UIView.animate(withDuration: 0.5, delay: 0, usingSpringWithDamping: 1, initialSpringVelocity: 1, options: .curveEaseOut, animations: {
            
            self.menufilter.view.frame = CGRect(x: x, y: 0, width: self.widthMenu, height: UIScreen.main.bounds.size.height)
            
            self.blackView.alpha = 1
            
            AppDelegate.isShowMenu = false
            
        }, completion: nil)
        
        
    }
    
    func closeMenuFilter() {
        menufilter.view.endEditing(true)
        UIView.animate(withDuration: 0.5, delay: 0, usingSpringWithDamping: 1, initialSpringVelocity: 1, options: .curveEaseOut, animations: {
            
            self.menufilter.view.frame = CGRect(x: UIScreen.main.bounds.size.width, y: 0, width: self.widthMenu, height: UIScreen.main.bounds.size.height)
            
            self.blackView.alpha = 0
            
        }) { (complete) in
            
            self.menufilter.view.isHidden = true
            self.menufilter.popToRootViewController(animated: false)
            
        }
        
        AppDelegate.isShowMenu = true
    }
    
    //--endFilter
    
    
    
    //--sortMenu
    
    @objc func editSortMenu() {
        
        if AppDelegate.isShowSort {
            showSortMenu()
        } else {
            dismissSortMenu()
        }
        
    }
    
    
    
    func showSortMenu() {
        
        menuSort.view.isHidden = false
        let isDefaultOrders = menuSort.isDefaultOrders
        guard let countCell = menuSort.orders?.count else { return }
        AppDelegate.isShowSort = false
        
        UIView.animate(withDuration: 0.5, delay: 0, usingSpringWithDamping: 1, initialSpringVelocity: 1, options: .curveEaseOut, animations: {
            
            self.blackViewSortMenu.alpha = 1
            self.heightMenuSort?.constant = isDefaultOrders ? CGFloat(countCell) * 38 : CGFloat(countCell - 1) * 38
            self.view.layoutIfNeeded()
            
        }, completion: { (complete) in
            
        })
        
    }
    
    func dismissSortMenu() {
        AppDelegate.isShowSort = true
        
        UIView.animate(withDuration: 0.5, delay: 0, usingSpringWithDamping: 1, initialSpringVelocity: 1, options: .curveEaseOut, animations: {
            
            self.blackViewSortMenu.alpha = 0
            self.heightMenuSort?.constant = 0
            self.view.layoutIfNeeded()
            
        }, completion: { (complete) in
            
            self.menuSort.view.isHidden = true
        })
    }
    
    
    func sortingMenu(order: String) {
        
        filterLoad()
        AppDelegate.changeFilter = false
        
        search["order"] = order
        search["offset"] = 0
        
        sortButton.setTitle(nameSort, for: .normal)
        sortButton.layoutIfNeeded()
        
        searchProduct()
    }
    
    
    //--endSortMneu
    
}

















