//
//  CollectionBanners.swift
//  Flip
//
//  Created by Anatoliy Matveev on 10.11.2017.
//  Copyright © 2017 Flip. All rights reserved.
//

import Foundation
import UIKit


class CollectionBanners: UICollectionView, UICollectionViewDelegate, UICollectionViewDataSource, UICollectionViewDelegateFlowLayout {
    
     var banners: [Banners]?
    
    func get(banners: [Banners]?, reload: Bool) {
        
        self.banners = banners
        
        if (banners?.count ?? 0) <= 1 {
            pageImageControll?.isHidenPageImage(true)
        } else {
            pageImageControll?.isHidenPageImage(false)
        }
        
        pageImageControll?.numberPageImage(count: banners?.count ?? 0)

        self.index = 0
        //            self.pageControl.currentPage = 0
        
        stopAndStartScrollBanner()
        
        if reload {
            self.reloadData()
        } else {
            self.performBatchUpdates({
                self.reloadSections([0])
            }, completion: nil)
        }
        
    }
    
    weak var transitionURL: TransitionURL?
    
    private var timer: RepeatTimer?
    
    weak var pageImageControll: PageImageControll?
    
    override init(frame: CGRect, collectionViewLayout layout: UICollectionViewLayout) {
        super.init(frame: frame, collectionViewLayout: layout)
        
        
        self.delegate = self
        self.dataSource = self
        self.backgroundColor = backGround
        
        
        self.register(CellForBanner.self)
        
//        setupPageControll()
        
    }
    
    
    override func reloadData() {
        super.reloadData()
        scrollToItem()
    }
    
    func scrollToItem() {
//        if index != 0 {
//            DispatchQueue.main.async {
//                let number = lroundf(Float(self.index))
//                let item = (number == self.banners?.count) ? 0 : number
//                self.scrollToItem(at: IndexPath(item: item, section: 0), at: UICollectionViewScrollPosition.centeredHorizontally, animated: false)
//            }
//        }
        
        DispatchQueue.main.async {
            if let currentPage = self.pageImageControll?.currentImage {
                if currentPage != 0 {
                    
                    let indexPath = IndexPath(item: currentPage, section: 0)
                    self.scrollToItem(at: indexPath, at: .centeredHorizontally, animated: false)
                    //                        self.collectionViewLayout.invalidateLayout()
                }
            }
        }
    }
    
    required init?(coder aDecoder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
    
    
    
    
//    let pageControl: UIPageControl = {
//        let page = UIPageControl()
//        page.currentPage = 0
//        page.pageIndicatorTintColor = UIColor.gray
//        page.currentPageIndicatorTintColor = UIColor.red
//        page.translatesAutoresizingMaskIntoConstraints = false
//        return page
//    }()
    
    
    
    

    
    func stopAndStartScrollBanner() {
        timer?.invalidate()
        
        timer = RepeatTimer { [weak self] in
            self?.animation()
        }
    }
    
    var index: CGFloat = 0
    
    
    func animation() {
        index = self.contentOffset.x / frame.width + 1
        let number = lroundf(Float(index))
//        pageControl.currentPage = (number == banners?.count) ? 0 : number
        pageImageControll?.currentPageImage(page: (number == banners?.count) ? 0 : number)
        let offsetX = index * frame.width
        
        UIView.animate(withDuration: 1, delay: 0, usingSpringWithDamping: 1, initialSpringVelocity: 1, options: .curveEaseInOut, animations: {
            //            self.collectionView.contentOffset.x = offsetX - 0.5
            if number == self.banners?.count {
                self.setContentOffset(.zero, animated: true)
            } else {
                self.contentOffset.x = offsetX - 0.3
            }
        }) { (complete) in
            //            if number == self.banners?.count {
            //                self.collectionView.contentOffset.x = 0
            //            } else {
            //                self.collectionView.contentOffset.x = offsetX
            //            }
        }
    }
    
    func collectionView(_ collectionView: UICollectionView, numberOfItemsInSection section: Int) -> Int {
        //        guard  let count = banners?.count, count > 0 else { return 0 }
        //        return count + 1
        return banners?.count ?? 0
    }
    
    func collectionView(_ collectionView: UICollectionView, cellForItemAt indexPath: IndexPath) -> UICollectionViewCell {
        let cell = collectionView.dequeueCell(for: indexPath) as CellForBanner
        //        let index = (indexPath.row == banners?.count) ? 0 : indexPath.row
        //        cell.banner = banners?[index]
        cell.banner = banners?[indexPath.item]
        return cell
    }
    
    
    
    func collectionView(_ collectionView: UICollectionView, didSelectItemAt indexPath: IndexPath) {
        
        let url = banners?[indexPath.item].url
        print("URL - ", url as Any)
        
        let parsURL = ParsURL()
        parsURL.urlComponents(url: url) { [weak self] (search) in
            self?.transitionURL?.transitionURL(object: search, title: nil)
        }
        
    }
    
    
    func collectionView(_ collectionView: UICollectionView, layout collectionViewLayout: UICollectionViewLayout, sizeForItemAt indexPath: IndexPath) -> CGSize {
        
        return collectionView.bounds.size
    }
    
    func collectionView(_ collectionView: UICollectionView, layout collectionViewLayout: UICollectionViewLayout, minimumLineSpacingForSectionAt section: Int) -> CGFloat {
        return 0
    }
    
    func collectionView(_ collectionView: UICollectionView, layout collectionViewLayout: UICollectionViewLayout, minimumInteritemSpacingForSectionAt section: Int) -> CGFloat {
        return 0
    }
    
    
    
    func scrollViewWillEndDragging(_ scrollView: UIScrollView, withVelocity velocity: CGPoint, targetContentOffset: UnsafeMutablePointer<CGPoint>) {
        
        stopAndStartScrollBanner()
        index = targetContentOffset.pointee.x / frame.width
        let number = Int(index)
//        pageControl.currentPage = (number == banners?.count) ? 0 : number
        
        pageImageControll?.currentPageImage(page: (number == banners?.count) ? 0 : number)
    }
    
    
//    func setupPageControll() {
//
//        //        let viewTest = UIView()
//        //        viewTest.backgroundColor = .red
//        //        viewTest.translatesAutoresizingMaskIntoConstraints = false
//        //
//        //        addSubview(viewTest)
//        //        viewTest.anchor(top: nil, left: leftAnchor, bottom: bottomAnchor, right: rightAnchor, topConstant: 0, leftConstant: 0, bottomConstant: 0, rightConstant: 0, widthConstant: 0, heightConstant: 20)
//
//        addSubview(pageControl)
//        bringSubview(toFront: pageControl)
//
//        NSLayoutConstraint.activate([
//            pageControl.centerXAnchor.constraint(equalTo: centerXAnchor),
//            pageControl.bottomAnchor.constraint(equalTo: bottomAnchor, constant: 4)
//            ])
//    }
    
    deinit {
        timer?.invalidate()
    }
    
    
    
    
}





























