//
//  CollectionSections.swift
//  Flip
//
//  Created by Anatoliy Matveev on 10.11.2017.
//  Copyright © 2017 Flip. All rights reserved.
//

import Foundation
import UIKit


class CollectionSections: UICollectionView, UICollectionViewDelegate, UICollectionViewDataSource, UICollectionViewDelegateFlowLayout {
    

    
    var sections: [Sections]? 
    
    
    func get(sections: [Sections]?, reload: Bool) {
        
        self.sections = sections
        
        if reload {
            self.reloadData()
        } else {
            self.performBatchUpdates({
                self.reloadSections([0])
            }, completion: nil)
        }
    }
    
    
    
    weak var sectionPush: SectionPush?
    
    
    override init(frame: CGRect, collectionViewLayout layout: UICollectionViewLayout) {
        super.init(frame: frame, collectionViewLayout: layout)
        
        
        self.delegate = self
        self.dataSource = self
        self.backgroundColor = backGround
        
        self.register(SubSectionsCell.self)
        
        
    }
    
    required init?(coder aDecoder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
    
    
    
    
 
    
    
    

    

    
    func collectionView(_ collectionView: UICollectionView, numberOfItemsInSection section: Int) -> Int {

        return sections?.count ?? 0
    }
    
    func collectionView(_ collectionView: UICollectionView, cellForItemAt indexPath: IndexPath) -> UICollectionViewCell {
        
        let cell = collectionView.dequeueCell(for: indexPath) as SubSectionsCell
        return cell

    }

    
    

    
    
    func collectionView(_ collectionView: UICollectionView, layout collectionViewLayout: UICollectionViewLayout, sizeForItemAt indexPath: IndexPath) -> CGSize {
        
        
        switch collectionView.frame.width {
        // iPhone landscape
        case 568, 667, 736, 768:
            return CGSize(width: collectionView.frame.width / 3 - 5, height: collectionView.frame.width / 3 + 30)
        case 1024, 1112:
            return CGSize(width: collectionView.frame.width / 4 - 5, height: collectionView.frame.width / 4 + 30)
        case 1366:
            return CGSize(width: collectionView.frame.width / 5 - 5, height: collectionView.frame.width / 5 + 30)
        default:
            // iPhone portrait
            return CGSize(width: collectionView.frame.width / 2 - 5, height: collectionView.frame.width / 2 + 30)
        }

    }
    
    func collectionView(_ collectionView: UICollectionView, layout collectionViewLayout: UICollectionViewLayout, minimumLineSpacingForSectionAt section: Int) -> CGFloat {
        return 3
    }
    
    func collectionView(_ collectionView: UICollectionView, layout collectionViewLayout: UICollectionViewLayout, minimumInteritemSpacingForSectionAt section: Int) -> CGFloat {
        return 0
    }
    
    
    
    func collectionView(_ collectionView: UICollectionView, layout collectionViewLayout: UICollectionViewLayout, insetForSectionAt section: Int) -> UIEdgeInsets {
        
        return UIEdgeInsets(top: 0, left: 4, bottom: 3, right: 4)
    }
    
    
 
    

    
    func collectionView(_ collectionView: UICollectionView, willDisplay cell: UICollectionViewCell, forItemAt indexPath: IndexPath) {

        cell.layer.shouldRasterize = true
        cell.layer.rasterizationScale = UIScreen.main.scale


        let cell = cell as! SubSectionsCell
        cell.reset()
        cell.sections = sections?[indexPath.item]


    }
    
    

    
    
    func collectionView(_ collectionView: UICollectionView, didSelectItemAt indexPath: IndexPath) {
        
        guard
            let id = sections?[indexPath.item].id,
            let discount = sections?[indexPath.item].discount
            else {
                return
        }
        
        
        sectionPush?.sectionPush(id: id, discount: discount, name: sections?[indexPath.item].name)
        
    }
  
    
    
  

    
    
    
}
