//
//  ProdSecFill.swift
//  Flip
//
//  Created by Анатолий Матвеев on 11.11.2017.
//  Copyright © 2017 Flip. All rights reserved.
//

import Foundation
import UIKit

class ProdSecFill: UICollectionView, UICollectionViewDelegate, UICollectionViewDataSource, UICollectionViewDelegateFlowLayout {
    
    var firstLoad = true
    
    var products: [Products]? {
        didSet {
            guard products != nil else { return }
            
        }
    }
    
    
    weak var refreshProdSec: RefreshProdSec?
    
    weak var prodSecFillPush: ProdSecFillPush?
    
    weak var addItemProdSec: AddItemProdSec?
    
    override init(frame: CGRect, collectionViewLayout layout: UICollectionViewLayout) {
        super.init(frame: frame, collectionViewLayout: layout)
        
        
        self.delegate = self
        self.dataSource = self
        self.backgroundColor = backGround
        
        self.register(CellProductSecV4.self)
    }
    
    
    
    
    
    func collectionView(_ collectionView: UICollectionView, numberOfItemsInSection section: Int) -> Int {
        
        return products?.count ?? 0
    }
    
    func collectionView(_ collectionView: UICollectionView, cellForItemAt indexPath: IndexPath) -> UICollectionViewCell {
        
        let cell = collectionView.dequeueCell(for: indexPath) as CellProductSecV4
        return cell
    }
    
    

    
    func collectionView(_ collectionView: UICollectionView, willDisplay cell: UICollectionViewCell, forItemAt indexPath: IndexPath) {
        
        cell.layer.shouldRasterize = true
        cell.layer.rasterizationScale = UIScreen.main.scale
        
        
        let cell = cell as! CellProductSecV4
        cell.resetValueLabel()
        cell.products = products?[indexPath.item]
        
        
        addItemProdSec?.addItem(indexPath: indexPath)
        
    }

 
    
    func collectionView(_ collectionView: UICollectionView, didSelectItemAt indexPath: IndexPath) {
        
        if products?.count != 0, let id = products?[indexPath.item].idProduce {
            
            prodSecFillPush?.prodSecFill(id: id) 
        }
    }
    
    
    
    
    
    
    func collectionView(_ collectionView: UICollectionView, layout collectionViewLayout: UICollectionViewLayout, sizeForItemAt indexPath: IndexPath) -> CGSize {
        
        
        if UIDevice.current.model == "iPad" {
            return CGSize(width: collectionView.frame.width, height: 250)
        }
        
        return CGSize(width: collectionView.frame.width, height: 150)
        
        //            switch view.frame.width {
        //
        //            case 414:
        //                return CGSize(width: view.frame.width / 3 - 8, height: 300)
        //            // iPhone landscape
        //            case 568:
        //                return CGSize(width: view.frame.width / 3 - 8, height: 300)
        //            case 667:
        //                return CGSize(width: view.frame.width / 4 - 8, height: 300)
        //            case 736, 768:
        //                return CGSize(width: view.frame.width / 5 - 8, height: 300)
        //            // iPad
        //            case 1024, 1112, 1366:
        //                return CGSize(width: view.frame.width / 6 - 8, height: 300)
        //            default:
        //                // iPhone portrait
        //                return CGSize(width: view.frame.width / 2 - 8, height: 300)
        //            }
        
    }
    
    
    
    func collectionView(_ collectionView: UICollectionView, layout collectionViewLayout: UICollectionViewLayout, referenceSizeForHeaderInSection section: Int) -> CGSize {
        
        return .zero
    }
    
    
    func collectionView(_ collectionView: UICollectionView, layout collectionViewLayout: UICollectionViewLayout, minimumLineSpacingForSectionAt section: Int) -> CGFloat {
        
        return 8
    }
    
    func collectionView(_ collectionView: UICollectionView, layout collectionViewLayout: UICollectionViewLayout, minimumInteritemSpacingForSectionAt section: Int) -> CGFloat {
        
        return 0
    }
    
    func collectionView(_ collectionView: UICollectionView, layout collectionViewLayout: UICollectionViewLayout, insetForSectionAt section: Int) -> UIEdgeInsets {
        
        return UIEdgeInsets(top: 8, left: 0, bottom: 8, right: 0)
    }
    
    
    
    func scrollViewDidEndDragging(_ scrollView: UIScrollView, willDecelerate decelerate: Bool) {
        
        refreshProdSec?.refresh()
        
    }
    
    
    
    required init?(coder aDecoder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
}





















