//
//  ProdSecFillTV.swift
//  Flip
//
//  Created by Anatoliy Matveev on 15.11.2017.
//  Copyright © 2017 Flip. All rights reserved.
//

import Foundation
import UIKit



class ProdSecFillTV: UITableView, UITableViewDelegate, UITableViewDataSource {
    
    var firstLoad = true
    
    var products: [Products]? {
        didSet {
            guard products != nil else { return }
            
        }
    }
    
    
    weak var refreshProdSec: RefreshProdSec?
    
    weak var prodSecFillPush: ProdSecFillPush?
    
    weak var addItemProdSec: AddItemProdSec?
    
    override init(frame: CGRect, style: UITableViewStyle) {
        super.init(frame: frame, style: style)
        
        
        self.delegate = self
        self.dataSource = self
        self.backgroundColor = backGround
        
        self.registerCell(CellProductSecV4TV.self)
    }
    
    
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return products?.count ?? 0
    }
    
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        
        let cell = tableView.dequeueCell(for: indexPath) as CellProductSecV4TV
        return cell
    }
    
    
    func tableView(_ tableView: UITableView, willDisplay cell: UITableViewCell, forRowAt indexPath: IndexPath) {
        
        cell.layer.shouldRasterize = true
        cell.layer.rasterizationScale = UIScreen.main.scale
        
        
        let cell = cell as! CellProductSecV4TV
        cell.resetValueLabel()
        cell.products = products?[indexPath.item]
        
        
        addItemProdSec?.addItem(indexPath: indexPath)
        
    }
    
    
    
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        
        if products?.count != 0, let id = products?[indexPath.item].idProduce {
            
            prodSecFillPush?.prodSecFill(id: id)
        }
        
    }
    
    
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        
        if UIDevice.current.model == "iPad" {
            return 250
        }
        
        return 150
        
    }
    
    
    
    
    
    func scrollViewDidEndDragging(_ scrollView: UIScrollView, willDecelerate decelerate: Bool) {
        
        refreshProdSec?.refresh()
        
    }
    
    
    
    required init?(coder aDecoder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
}




















