//
//  ProductSection.swift
//  Flip
//
//  Created by Анатолий Матвеев on 10.11.2017.
//  Copyright © 2017 Flip. All rights reserved.
//

import Foundation
import UIKit



class ProductSection: UICollectionView, UICollectionViewDelegate, UICollectionViewDataSource, UICollectionViewDelegateFlowLayout {
    

    var products: [Products]? 
    
    func get(products: [Products]?, reload: Bool) {
        
        self.products = products
        
        if reload {
            self.reloadData()
        } else {
            self.performBatchUpdates({
                self.reloadSections([0])
            }, completion: nil)
        }
    }
    
    
//    var titleHeader: String?
//    var urlHeader: String?
    
    weak var pushController: PushController?
    
    var collectionViewOffset: CGFloat {
        set {
            self.contentOffset.x = newValue
        }
        get {
            return self.contentOffset.x
        }
    }
    
    //    weak var controller: UICollectionViewController?
    
    weak var productSectionPush: ProductSectionPush?

    
    override init(frame: CGRect, collectionViewLayout layout: UICollectionViewLayout) {
        super.init(frame: frame, collectionViewLayout: layout)
        
        self.delegate = self
        self.dataSource = self
        self.backgroundColor = backGround
        
        self.register(CellProductSecV3.self)
    }
    
    
    func collectionView(_ collectionView: UICollectionView, numberOfItemsInSection section: Int) -> Int {
        return products?.count ?? 0
    }
    
    func collectionView(_ collectionView: UICollectionView, cellForItemAt indexPath: IndexPath) -> UICollectionViewCell {
        
        let cell = collectionView.dequeueCell(for: indexPath) as CellProductSecV3
        return cell
        
    }
    
    func collectionView(_ collectionView: UICollectionView, willDisplay cell: UICollectionViewCell, forItemAt indexPath: IndexPath) {
        
//        cell.layer.shouldRasterize = true
//        cell.layer.rasterizationScale = UIScreen.main.scale
        
        let cell = cell as! CellProductSecV3
        cell.reset()
        cell.products = products?[indexPath.item]
        
    }
    
    
    func collectionView(_ collectionView: UICollectionView, layout collectionViewLayout: UICollectionViewLayout, sizeForItemAt indexPath: IndexPath) -> CGSize {
        
        return CGSize(width: 180, height: collectionView.frame.height - 8)
        
        
    }
    
    func collectionView(_ collectionView: UICollectionView, layout collectionViewLayout: UICollectionViewLayout, insetForSectionAt section: Int) -> UIEdgeInsets {
        
        return UIEdgeInsets(top: 0, left: 8, bottom: 8, right: 8)
    }
    
    func collectionView(_ collectionView: UICollectionView, didSelectItemAt indexPath: IndexPath) {
        
        if let id = products?[indexPath.item].idProduce {
//            let shortName = products?[indexPath.item].nameExtra?.first
            productSectionPush?.productSectionPush(id: id)
//            pushController?.pushController(data: (id, shortName))
        }
        
    }
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    required init?(coder aDecoder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
    
    
}
