//
//  ScrollAPI.swift
//  Flip
//
//  Created by Anatoliy Matveev on 10.11.2017.
//  Copyright © 2017 Flip. All rights reserved.
//

import Foundation
import UIKit


extension ScrollCatalog {
    
    
    func fetchSubsection() {
        
        if categories || discount || urlSearch || wordSearch || descript || searchPublish {
            searchProduct()
        } else {
            let handler = Handler(url: ApiKey.getSectionBlocks, extra: .id(id))
            handler.getSectionBlock(completion: { (result) in
                switch result {
                case .Success(let json):
                    if let blocks = json.blocks, blocks.isEmpty {
                        self.searchProduct()
                    } else {
                        self.json = json
                    }
                case .Error(let error):
                    ErrorProcessing.shared.alert(error: error)
                }
                
            })
            
            //            fetchJsonData()
        }
        
    }
    
    //    func fetchJsonData() {
    //
    //        FetchJsonData.sharedInstance.getDataWith(id: id) { [weak self] (result) in
    //            guard let strongSelf = self else { return }
    //
    //            switch result {
    //            case .Success(let json):
    //
    //                if let blocks = json.blocks, blocks.isEmpty {
    //                    strongSelf.searchProduct()
    //                } else {
    //                    strongSelf.json = json
    //                }
    //
    //            case .Error(let error):
    //                DispatchQueue.main.async {
    //                    ErrorProcessing.shared.alert(error: error)
    //                }
    //            }
    //        }
    //    }
    
    
    func searchProduct() {
        //        AppDelegate.currentTask.cancel()
        SearchAndFilters.sharedInstance.getDataWith(productSearch: search) { [weak self] (result) in
            guard let strongSelf = self else { return }

            switch result {
            case .Success(let productSearch):
                
                if let products = strongSelf.prodSecFill.products, AppDelegate.changeFilter {
                    strongSelf.prodSecFill.products = products + (productSearch.products ?? [])

                    if let countNew = productSearch.products?.count {
                        var indexPath = [IndexPath]()
                        for i in 0..<countNew {
                            let item = products.count + i
                            let index = IndexPath(item: item, section: 0)
                            indexPath.append(index)
                        }

                        DispatchQueue.main.async {
                            strongSelf.prodSecFill.insertItems(at: indexPath)
                        }
                    }
                } else {
                    
                    AppDelegate.changeFilter = true
                    strongSelf.productSearch = productSearch
                    
                    if strongSelf.prodSecFill.firstLoad {
                        strongSelf.prodSecFill.firstLoad = false
                        strongSelf.prodSecFill.reloadData()
                    } else {
                        strongSelf.prodSecFill.reloadSections([0])
                        
                        if !strongSelf.refreshCollection.isRefreshing {
                            if strongSelf.prodSecFill.products?.count != 0 {
                                strongSelf.prodSecFill.scrollToItem(at: IndexPath(row: 0, section: 0), at: UICollectionViewScrollPosition.top, animated: false)
                            }
                        }
                        
                    }
                    
                    strongSelf.endRefresh()
                }


//                }
            case .Error(let error):
                DispatchQueue.main.async {
                    ErrorProcessing.shared.alert(error: error)
                }
            }
        }
    }
    
    
    
    func getData(url: String?, extra: Any? = nil) {
        
        guard var urlGet = url else { return }
        
        if let extra = extra {
            let property = String(stringInterpolationSegment: extra)
            urlGet += property
        }
        
        GetData.sharedInstance.getDataWith(url: urlGet) { (result) in
            
            switch result {
            case .Success(let data):
                print(data)
            case .Error(let error):
                ErrorProcessing.shared.alert(error: error)
            }
        }
    }
    
    
    
    
    
    
    
    
    
    
    
    
    
}






extension ScrollCatalog: AddItemProdSec {
    
    func addItem(indexPath: IndexPath) {
        DispatchQueue.main.async {
            guard let count = self.prodSecFill.products?.count else { return }
            guard let totalAll = self.productSearch?.totalAll else { return }
            
            guard Int(totalAll) != count else { return }
            
            if indexPath.item == (count - 5) {
                self.search["offset"] = count
                self.searchProduct()
            }
        }

    }
}













