//
//  SetupFilterScroll.swift
//  Flip
//
//  Created by Анатолий Матвеев on 11.11.2017.
//  Copyright © 2017 Flip. All rights reserved.
//

import Foundation
import UIKit
import FlexLayout

extension ScrollCatalog {
    
    
    func setupFilter() {
        setupMenu()
        setupMenuView()
        setupSortMenu()
    }
    
    
    
    
    func setupMenuView() {
        
        
//        menuView.flex.height(40).direction(.row).define { (flex) in
//            flex.addItem(sortButton).margin(4, 16, 4, 4).shrink(1)
//            flex.addItem().grow(1)
//            flex.addItem(filterButton).margin(4, 4, 4, 16)
//        }
//        
        
        
        view.addSubview(menuView)

        menuView.addSubview(sortButton)
        menuView.addSubview(filterButton)

        menuView.anchor(top: topLayoutGuide.bottomAnchor, left: view.leftAnchor, bottom: nil, right: view.rightAnchor, topConstant: 0, leftConstant: 0, bottomConstant: 0, rightConstant: 0, widthConstant: 0, heightConstant: 40)

        sortButton.anchor(top: menuView.topAnchor, left: menuView.leftAnchor, bottom: menuView.bottomAnchor, right: menuView.rightAnchor, topConstant: 4, leftConstant: 16, bottomConstant: 4, rightConstant: 80, widthConstant: 0, heightConstant: 0)

        filterButton.anchor(top: menuView.topAnchor, left: nil, bottom: menuView.bottomAnchor, right: menuView.rightAnchor, topConstant: 4, leftConstant: 0, bottomConstant: 4, rightConstant: 16, widthConstant: 0, heightConstant: 0)
    }
    
    
    func setupSortMenu() {
        
        view.addSubview(blackViewSortMenu)
        view.addSubview(menuSort.view)
        
        menuSort.view.isHidden = true
        menuSort.searchFilter = self
        
        blackViewSortMenu.alpha = 0
        
        menuSort.view.anchor(top: menuView.bottomAnchor, left: menuView.leftAnchor, bottom: nil, right: menuView.rightAnchor, topConstant: 0, leftConstant: 0, bottomConstant: 0, rightConstant: 0, widthConstant: 0, heightConstant: 0)
        
        heightMenuSort = menuSort.view.heightAnchor.constraint(equalToConstant: 0)
        heightMenuSort?.isActive = true
        
        blackViewSortMenu.anchor(top: menuView.bottomAnchor, left: view.leftAnchor, bottom: view.bottomAnchor, right: view.rightAnchor, topConstant: 0, leftConstant: 0, bottomConstant: 0, rightConstant: 0, widthConstant: 0, heightConstant: 0)
        
    }
    
    func setupMenu() {
        
        if let window = UIApplication.shared.keyWindow {
            
            window.addSubview(blackView)
            window.addSubview(menufilter.view)
            
            menufilter.view.isHidden = true
            
            if let menufilter = menufilter.viewControllers.first as? FilterMenu {
                menufilter.searchFilter = self
            }
            
            blackView.alpha = 0
            
            blackView.frame = CGRect(x: 0, y: 0, width: UIScreen.main.bounds.size.width, height: UIScreen.main.bounds.size.height)
            
            menufilter.view.frame = CGRect(x: UIScreen.main.bounds.size.width, y: 0, width: widthMenu, height: UIScreen.main.bounds.size.height)
        }
        
        
        menufilter.view.addGestureRecognizer(UISwipeGestureRecognizer(target: self, action: #selector(handleSwipeCloseMenu)))
        
    }
}





















