//
//  extScrollCatalog.swift
//  Flip
//
//  Created by Anatoliy Matveev on 10.11.2017.
//  Copyright © 2017 Flip. All rights reserved.
//

import Foundation
import UIKit


extension ScrollCatalog {
    
    
    func animateLoad() {
        UIView.animate(withDuration: 1, delay: 0, usingSpringWithDamping: 1, initialSpringVelocity: 1, options: .curveEaseOut, animations: {
            self.fonView.alpha = 0
            self.spinner.stopAnimating()
        }) { (completion) in
            //            self.fonView.removeFromSuperview()
            //            self.spinner.removeFromSuperview()
        }
    }
    
    func refreshanimateLoad() {
        UIView.animate(withDuration: 0.5, delay: 0, usingSpringWithDamping: 1, initialSpringVelocity: 1, options: .curveEaseOut, animations: {
            self.fonView.alpha = 1
            self.spinner.startAnimating()
        }) { (completion) in
            
        }
    }
    
    func load() {
        
        view.addSubview(fonView)
        view.bringSubview(toFront: fonView)
        fonView.addSubview(spinner)
        
        fonView.anchor(top: topLayoutGuide.bottomAnchor, left: view.leftAnchor, bottom: bottomLayoutGuide.topAnchor, right: view.rightAnchor, topConstant: 0, leftConstant: 0, bottomConstant: 0, rightConstant: 0, widthConstant: 0, heightConstant: 0)
        
        spinner.anchorCenterSuperview()
        
        spinner.startAnimating()
    }
}



extension ScrollCatalog: AllCategoriesPush {
    
    func allCategoriesPush() {
        guard let id = id else { return }
        //        let treeMenu = TreeMenu()
        //        treeMenu.id = "\(id)"
        //        navigationController?.pushViewController(treeMenu, animated: true)
        
        let testSectionMenu = TestSectionMenu()
        testSectionMenu.id = "\(id)"
        navigationController?.pushViewController(testSectionMenu, animated: true)
    }
}


extension ScrollCatalog: RefreshProdSec {
    func refresh() {
        
        if refreshControl.isRefreshing == true || refreshCollection.isRefreshing == true {
            DispatchQueue.main.async {
                print("test isRefreshing")
                self.search["offset"] = 0
                self.scrollView.isUserInteractionEnabled = false
                self.prodSecFill.isUserInteractionEnabled = false
                self.menuView.isUserInteractionEnabled = false
                AppDelegate.changeFilter = false
                self.fetchSubsection()
            }
        }
        
    }
}



















